#include <mega8.h>
#include <stdio.h>


unsigned char Data[512];
int j;

int addr;

unsigned char 	BreakCounter = 0;

void main(void)
{
// Declare your local variables here

// Input/Output Ports initialization
// Port B initialization
// Func7=In Func6=In Func5=In Func4=In Func3=Out Func2=Out Func1=Out Func0=In 
// State7=T State6=T State5=T State4=T State3=0 State2=0 State1=0 State0=T 
PORTB=0x00;
DDRB=0x0E;

// Port C initialization
// Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State6=P State5=P State4=P State3=P State2=P State1=P State0=P 
PORTC=0x7F;
DDRC=0x00;

// Port D initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
PORTD=0x00;
DDRD=0x00;

// Timer/Counter 1 initialization
// Clock source: System Clock
// Clock value: 62.500 kHz
// Mode: Fast PWM top=0x00FF
// OC1A output: Inverted
// OC1B output: Discon.
// Noise Canceler: Off
// Input Capture on Falling Edge
// Timer1 Overflow Interrupt: Off
// Input Capture Interrupt: Off
// Compare A Match Interrupt: Off
// Compare B Match Interrupt: Off
TCCR1A=0xC1;
TCCR1B=0x0C;
TCNT1H=0x00;
TCNT1L=0x00;
ICR1H=0x00;
ICR1L=0x00;
OCR1AH=0x00;
OCR1AL=0x00;
OCR1BH=0x00;
OCR1BL=0x00;


// USART initialization
// Communication Parameters: 8 Data, 2 Stop, No Parity
// USART Receiver: On
// USART Transmitter: Off
// USART Mode: Asynchronous
// USART Baud Rate: 250000
UCSRA=0x00;
UCSRB=0x10;
UCSRC=0x8E;
UBRRH=0x00;
UBRRL=0x03;



 
TCCR1A=0;
PORTB=0xff;                        

while (1)
      {
      // Place your code here
      
     addr=PINC;
      
    if( !PIND.3 )
    {
        if( BreakCounter++ == 100 )     
        {
        
            while ((!PIND.3 )){};
                                
            for ( j=0; j<512; j++) 
            {
                while ((!UCSRA.7 )){};
                Data[j] =  UDR;
            };   
                        
                OCR1AL  = Data[addr];   

        BreakCounter=0;
        } 
    }
    else     
    {
        BreakCounter = 0;
        if ( UCSRA.7 )
        Data[j] =  UDR;
    }      

   
      };
}
